%global mingw_build_ucrt64 1
%{?mingw_package_header}

Name:           mingw-SDL3
Version:        3.2.16
Release:        3%{?dist}
Summary:        MinGW Windows port of SDL3 cross-platform multimedia library

License:        Zlib AND MIT AND Apache-2.0 AND (Apache-2.0 OR MIT)
URL:            https://www.libsdl.org/
Source0:        https://www.libsdl.org/release/SDL3-%{version}.tar.gz
Patch0:         0001-cmake-disable-alloca-for-MinGW-builds.patch

BuildArch:      noarch

BuildRequires:  cmake
BuildRequires:  make
BuildRequires:  dos2unix

BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-gcc-c++

BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-gcc-c++

BuildRequires:  ucrt64-filesystem >= 95
BuildRequires:  ucrt64-gcc
BuildRequires:  ucrt64-gcc-c++

%ifarch %{ix86}
BuildRequires: nasm
%endif

%description
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


# Win32
%package -n mingw32-SDL3
Summary:        MinGW32 Windows port of SDL cross-platform multimedia library
# Long ago forked hidraw customized for SDL
Provides:       bundled(hidraw)

%description -n mingw32-SDL3
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Win32 (static)
%package -n mingw32-SDL3-static
Summary:        MinGW32 Windows port of SDL cross-platform multimedia library
Requires:       mingw32-SDL3 = %{version}-%{release}

%description -n mingw32-SDL3-static
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Win64
%package -n mingw64-SDL3
Summary:        MinGW64 Windows port of SDL cross-platform multimedia library
# Long ago forked hidraw customized for SDL
Provides:       bundled(hidraw)

%description -n mingw64-SDL3
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Win64 (static)
%package -n mingw64-SDL3-static
Summary:        MinGW64 Windows port of SDL cross-platform multimedia library
Requires:       mingw64-SDL3 = %{version}-%{release}

%description -n mingw64-SDL3-static
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# UCRT64
%package -n ucrt64-SDL3
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Provides:       bundled(hidraw)

%description -n ucrt64-SDL3
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# UCRT64 (static)
%package -n ucrt64-SDL3-static
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Requires:       ucrt64-SDL3 = %{version}-%{release}

%description -n ucrt64-SDL3-static
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

%{?mingw_debug_package}


%prep
%autosetup -p1 -n SDL3-%{version}


%build
%mingw_cmake -DSDL_STATIC=ON -DSDL_STATIC_PIC=ON -DSDL_VENDOR_INFO="%{?dist_vendor} %{version}-%{release}"
%mingw_make_build


%install
%mingw_make_install

rm -rf %{buildroot}%{mingw32_datadir}/licenses
rm -rf %{buildroot}%{mingw64_datadir}/licenses
rm -rf %{buildroot}%{ucrt64_datadir}/licenses


# Win32
%files -n mingw32-SDL3
%license LICENSE.txt
%{mingw32_bindir}/SDL3.dll
%{mingw32_libdir}/libSDL3.dll.a
%{mingw32_libdir}/libSDL3_test.a
%{mingw32_libdir}/cmake/SDL3/
%exclude %{mingw32_libdir}/cmake/SDL3/*static*
%{mingw32_libdir}/pkgconfig/sdl3.pc
%{mingw32_includedir}/SDL3

# Win32 (static)
%files -n mingw32-SDL3-static
%{mingw32_libdir}/libSDL3.a
%{mingw32_libdir}/cmake/SDL3/*static*

# Win64
%files -n mingw64-SDL3
%license LICENSE.txt
%{mingw64_bindir}/SDL3.dll
%{mingw64_libdir}/libSDL3.dll.a
%{mingw64_libdir}/libSDL3_test.a
%{mingw64_libdir}/cmake/SDL3/
%exclude %{mingw64_libdir}/cmake/SDL3/*static*
%{mingw64_libdir}/pkgconfig/sdl3.pc
%{mingw64_includedir}/SDL3

# Win64 (static)
%files -n mingw64-SDL3-static
%{mingw64_libdir}/libSDL3.a
%{mingw64_libdir}/cmake/SDL3/*static*

# UCRT64
%files -n ucrt64-SDL3
%license LICENSE.txt
%{ucrt64_bindir}/SDL3.dll
%{ucrt64_libdir}/libSDL3.dll.a
%{ucrt64_libdir}/libSDL3_test.a
%{ucrt64_libdir}/cmake/SDL3/
%exclude %{ucrt64_libdir}/cmake/SDL3/*static*
%{ucrt64_libdir}/pkgconfig/sdl3.pc
%{ucrt64_includedir}/SDL3

# UCRT64 (static)
%files -n ucrt64-SDL3-static
%{ucrt64_libdir}/libSDL3.a
%{ucrt64_libdir}/cmake/SDL3/*static*

%changelog
* Sun Jul 13 2025 Jack Greiner <jack@emoss.org> - 3.2.16-3
- Add patch to bruteforce disable alloca on mingw builds

* Sun Jul 13 2025 Jack Greiner <jack@emoss.org> - 3.2.16-2
- Add UCRT64 build
- Add patch to fix alloca detection

* Fri Jul 04 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.16-1
- Update to 3.2.16

* Fri May 09 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.12-1
- Update to 3.2.12

* Fri Apr 11 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.10-1
- Update to 3.2.10

* Sun Mar 16 2025 Simone Caronni <negativo17@gmail.com> - 3.2.8-1
- Update to 3.2.8.

* Sat Feb 08 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.4-1
- Update to 3.2.4

* Mon Feb 03 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.2-1
- Update to 3.2.2

* Wed Jan 22 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.2.0-1
- Update to 3.2.0 (SDL3 GA)

* Thu Jan 16 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.1.10-1
- Update to 3.1.10

* Thu Jan 09 2025 Neal Gompa <ngompa@fedoraproject.org> - 3.1.8-1
- Update to 3.1.8

* Mon Dec 02 2024 Neal Gompa <ngompa@fedoraproject.org> - 3.1.6-1
- Initial package
